//
//  ConvolutionMaskProtocol.h
//  MotionDetection
//
//  Created by Kévin Toublanc on 10/04/12.
//  Copyright (c) 2012 Polytech'Tours. All rights reserved.
//

#import <Foundation/Foundation.h>
#define NB_OCTET_PAR_PIXEL 4
@protocol ConvolutionMaskDelegate;

@protocol ConvolutionMaskProtocol <NSObject>

@required    

@property (nonatomic) uint8_t * imageData;
@property (nonatomic) CGSize imageSize;
@property (nonatomic) int * result;
@property (weak) NSObject<ConvolutionMaskDelegate>* delegate;
@property (nonatomic) int * mask;
@property (nonatomic) CGSize maskSize;


-(id<ConvolutionMaskProtocol>) initWithImage:(uint8_t*) image 
                                    imageSize:(CGSize) imageSize 
                                 resultImage:(int*) resultImage
                                        mask:(int*) mask 
                                    maskSize:(CGSize) maskSize
                                    delegate:(NSObject<ConvolutionMaskDelegate>*)delegate 
                                         lut:(int***)lutM;

-(void) applyMask;

@end


@protocol ConvolutionMaskDelegate <NSObject>

@required
-(void) maskAppliedOnPixelNumber:(unsigned int) pixelNumber;
-(void) maskDidBeginBeingApplied;
-(void) maskDidFinishBeingApplied;
@end