//
//  NSException+Custom.m
//  MotionDetection
//
//  Created by Kevin Toublanc on 04/01/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "NSException+Custom.h"

@implementation NSException (Custom)

+(NSException *)NotImplementedException{
    return [[NSException alloc]initWithName:@"Not Implemented Exception" 
                                    reason:@"The method has not been implemented" 
                                  userInfo:nil] ;
}

+(NSException*) PropertyNotAssignedException:(NSString*)propertyName{
    return [[NSException alloc]initWithName:@"Property Not Assigned Exception" 
                                     reason:[[NSString alloc] initWithFormat:@"The property %@ was not assigned and is needed to continue.", propertyName] 
                                   userInfo:nil] ;
}

+(NSException*) IndexOutOfBoundsException:(NSInteger)index{
    return [[NSException alloc]initWithName:@"Index Out of Bounds Exception" 
                                     reason:[[NSString alloc] initWithFormat:@"The index %d is out of the array bounds", index] 
                                   userInfo:nil] ;
}
@end
