//
//  Frame.h
//  MotionDetection
//
//  Created by Kevin Toublanc on 04/01/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreVideo/CoreVideo.h>
#import <CoreMotion/CoreMotion.h>
#import "Geometry.h"

#define SEUIL_DELTA 0.0008  

#define iPad2CameraPositionX 07.08
#define iPad2CameraPositionY 10.865
#define iPad2CameraPositionZ 1.00

//#define iPad2ScreenSizeY 19.7
//#define iPad2ScreenSizeX 14.7

#define iPad2ScreenSizeY 80.0
#define iPad2ScreenSizeX 60.0

#define P1X  iPad2CameraPositionX - (iPad2ScreenSizeX / 2)
#define P1Y  iPad2CameraPositionY + (iPad2ScreenSizeY / 2)
#define P1Z 100.0//20.0

#define P2X  iPad2CameraPositionX + (iPad2ScreenSizeX / 2)
#define P2Y  iPad2CameraPositionY + (iPad2ScreenSizeY / 2)
#define P2Z 100.0//20.0

#define P3X  iPad2CameraPositionX - (iPad2ScreenSizeX / 2)
#define P3Y  iPad2CameraPositionY - (iPad2ScreenSizeY / 2)
#define P3Z 100.0//20.0

#define P4X  iPad2CameraPositionX + (iPad2ScreenSizeX / 2)
#define P4Y  iPad2CameraPositionY - (iPad2ScreenSizeY / 2)
#define P4Z 100.0//20.0




@class MotionCapture;

@interface Frame : NSObject{
@private
    CVImageBufferRef imageBufferRef;
    
    BOOL framePositionProcessed;
}

@property (strong, nonatomic, readonly) NSMutableArray * motions;

@property (readonly) double  xUserAcceleration;

@property (readonly) double  yUserAcceleration;

@property (readonly) double  zUserAcceleration;

@property (readonly, nonatomic) NSUInteger frameNumber;

@property (readonly, nonatomic) Point3D *points;

@property (readonly, nonatomic) Plane3D plane;

@property (strong, nonatomic) NSDate* startDate;

@property (nonatomic) NSTimeInterval frameInterval;

@property (nonatomic, readonly) CMAttitude * attitudeRef;



-(id) initWithFrameNumber:(NSUInteger)n imageBufferRef:(CVImageBufferRef)imageBuffer andStartDate:(NSDate*)date;

-(void) addCaptureMotion:(MotionCapture*)motion;

-(CVImageBufferRef) imageBufferRef;

-(void) calculFramePosition:(Frame*)previousFrame;

@end
