//
//  FrameIntersectionManager.h
//  MotionDetection
//
//  Created by Kevin Toublanc on 08/03/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Geometry.h"
#import "Frame.h"


@interface FrameIntersectionManager : NSObject

@property (nonatomic, weak) Frame * firstFrame;

@property (nonatomic, weak) Frame * secondFrame;

@property (nonatomic, readonly) Plane3D * medianPlane;

@property (nonatomic, readonly) Point2D ** projectedVertices2D;

@property (nonatomic, readonly) Line2D ** projectedLines2D;

@property (nonatomic, readonly) Point3D * intersectVertices;

@property (nonatomic, readonly) Vector3D * normal;

@property (nonatomic) unsigned int intersectVerticesNumber;


-(id)initWithFirstFrame:(Frame*)first andSecondFrame:(Frame*)second;
-(Point3D*) intersectFrames; 
-(Point2D*) projectPoint:(Point2D)pointInFrameCoordinates;
@end
