//
//  Geometry.c
//  MotionDetection
//
//  Created by Kevin Toublanc on 15/03/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "Geometry.h"

Plane3D MDMedianPlane(Plane3D firstPlane, Plane3D secondPlane){
    Plane3D _medianPlane = 
    {
        {
            (firstPlane.origin.x + secondPlane.origin.x) / 2.0, 
            (firstPlane.origin.y + secondPlane.origin.y) / 2.0, 
            (firstPlane.origin.z + secondPlane.origin.z) / 2.0
        },
        {
            {
                (firstPlane.vectors[0].x + secondPlane.vectors[0].x) / 2.0,
                (firstPlane.vectors[0].y + secondPlane.vectors[0].y) / 2.0,
                (firstPlane.vectors[0].z + secondPlane.vectors[0].z) / 2.0
            },
            {
                (firstPlane.vectors[1].x + secondPlane.vectors[1].x) / 2.0,
                (firstPlane.vectors[1].y + secondPlane.vectors[1].y) / 2.0,
                (firstPlane.vectors[1].z + secondPlane.vectors[1].z) / 2.0
            }
        },
        {
            {
                // 0, 0, 0
            },
            {
                // 0, 0, 0
            }
        }
    };
    

    double tmp = sqrt(pow(_medianPlane.vectors[0].x, 2)+ pow(_medianPlane.vectors[0].y, 2) + pow(_medianPlane.vectors[0].z, 2));
    _medianPlane.normalizedVectors[0].x =  _medianPlane.vectors[0].x / tmp;
    _medianPlane.normalizedVectors[0].y =  _medianPlane.vectors[0].y / tmp;
    _medianPlane.normalizedVectors[0].z =  _medianPlane.vectors[0].z / tmp;
    
    tmp = sqrt(pow(_medianPlane.vectors[1].x, 2)+ pow(_medianPlane.vectors[1].y, 2) + pow(_medianPlane.vectors[1].z, 2));
    _medianPlane.normalizedVectors[1].x =  _medianPlane.vectors[1].x / tmp;
    _medianPlane.normalizedVectors[1].y =  _medianPlane.vectors[1].y / tmp;
    _medianPlane.normalizedVectors[1].z =  _medianPlane.vectors[1].z / tmp;
    
    return _medianPlane;
}


Point3D MDProjectPointOntoPlaneWhithOrthogonalProjection(Point3D point, Plane3D plane, Vector3D normal){
    
    
    /*Projection du point sur le plan*/    
    double alpha = normal.x * (point.x - plane.origin.x);
    double beta = normal.y * (point.y - plane.origin.y);
    double gamma = normal.z * (point.z - plane.origin.z);
    double k = (-alpha-beta-gamma) / (pow(normal.x, 2)+pow(normal.z, 2)+pow(normal.z, 2));
    
    /*Création du point projeté*/
    Point3D p =
    {
        k*normal.x + point.x,
        k*normal.y + point.y,
        k*normal.z + point.z
    };
    return p;
    
}

Vector3D MDNormalVectorFromPlane(Plane3D plane){
    Vector3D vect = 
    {
        (plane.vectors[0].y * plane.vectors[1].z) - (plane.vectors[0].z * plane.vectors[1].y),
        (plane.vectors[0].x * plane.vectors[1].z) - (plane.vectors[0].z * plane.vectors[1].x),
        (plane.vectors[0].x * plane.vectors[1].y) - (plane.vectors[0].y * plane.vectors[1].x)
    };
    return vect;
}

Point2D MDTransform3DPointIn2DPoint(Point3D point, Plane3D plane){
    point.x-=plane.origin.x;
    point.y-=plane.origin.y;
    point.z-=plane.origin.z;
    Point2D finalPoint;
    finalPoint.y = (point.y * plane.normalizedVectors[0].x - point.x * plane.normalizedVectors[0].y) / 
                   (plane.normalizedVectors[1].y * plane.normalizedVectors[0].x - plane.normalizedVectors[1].x * plane.normalizedVectors[0].y);
    finalPoint.x = (point.x - finalPoint.y * plane.normalizedVectors[1].x) / plane.normalizedVectors[0].x;
    return finalPoint;
}
