//
//  LutMatrix.c
//  MotionDetection
//
//  Created by Kévin Toublanc on 12/04/12.
//  Copyright (c) 2012 Polytech'Tours. All rights reserved.
//

#import "LutMatrix.h"

int *** getLutMatrix(float alpha, float beta, float gamma){
    
    int *** lut = malloc(256 * sizeof(int**));
    
    for (int i = 0; i < 256; i++) {
        
        lut[i] = malloc(256 * sizeof(int*));
        
        for (int j = 0 ; j < 256; j++) {
            
            lut[i][j] = malloc(256 * sizeof(int));
            
            for (int k = 0; k < 256; k++) {
                
                lut[i][j][k] = alpha * (float)i + beta * (float)j + gamma* (float)k;
                
            }
        }
    }
    
    return lut;
}

void freeLut(int *** lut){
    for (int i = 0; i < 256; i++) {
        
        for (int j = 0 ; j < 256; j++) {
            
            free(lut[i][j]);            
        }
        
        free(lut[i]);
    }
    
    free(lut);

}