//
//  MotionDetectionOperation.m
//  MotionDetection
//
//  Created by Kevin Toublanc on 27/01/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MotionMovementCalculOperation.h"
#import "FrameIntersectionManager.h"
#import "Geometry.h"
#import "Frame.h"
@implementation MotionMovementCalculOperation

@synthesize queue;
@synthesize processedFrame=_processedFrame;

- (id)initWithFrameProcessingQueue:(CircularFrameProcessingQueue*) q {
    self = [super init];
    if (self) {
        queue = q;
        _processedFrame = [q previousFrame];
        previousFrame = [q previousFrame:2];
    }
    return self;
}

-(void)main{
    if ([self isCancelled] || !_processedFrame || !previousFrame)return;
    
    /*Calcul des déplacements*/
    [_processedFrame calculFramePosition:previousFrame];
    
    /*Affichage des points*/
    
    Point2D point = {400,500.0};
    FrameIntersectionManager *manager = [[FrameIntersectionManager alloc] initWithFirstFrame:self.processedFrame andSecondFrame:previousFrame];
    Point2D * p = [manager projectPoint:point];
    
    NSLog(@"%f\%f",p->x, p->y);
    NSLog(@"Fin");
    
}
@end
