//
//  CircularFrameProcessingQueue.h
//  MotionDetection
//
//  Created by Kevin Toublanc on 31/12/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "CircularProcessingQueue.h"


@class Frame;
@class MotionCapture;
@interface CircularFrameProcessingQueue : CircularProcessingQueue <CircularProcessingQueueDelegate>

/*Constructors*/
-(id) init;
-(id) initWithSize:(NSUInteger)maxSize;

/*Add Motion Detection to a frame*/
-(void) addMotionCaptureToCurrentFrame:(MotionCapture*) motion;
-(void) addMotionCaptureToPreviousFrame:(MotionCapture*) motion;
-(void) addMotionCapture:(MotionCapture*) motion toPreviousFrame:(NSInteger)n;

/*Add Frames*/
-(void) addObject:(id)anObject;
-(void) addFrame:(Frame*) frame;

/*Navigate between frames*/
-(id) currentFrame;

-(id) previousFrame;

-(id) previousFrame:(NSUInteger)n;

-(id) frameAtIndex:(NSUInteger)index;

@end
