//
//  CircularFrameProcessingQueue.m
//  MotionDetection
//
//  Created by Kevin Toublanc on 31/12/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "CircularFrameProcessingQueue.h"
#import "Frame.h"
#import "NSException+custom.h"
@implementation CircularFrameProcessingQueue

/*Constructors*/
- (id)init {
    self = [super init];
    if (self) {
        
    }
    return self;
}
-(id) initWithSize:(NSUInteger)maxSize{
    self = [super initWithSize:maxSize];
    if(self){
        [super setDelegate:self];
    }
    return self;
}

/*Add Motion Detection to a frame*/
-(void) addMotionCaptureToCurrentFrame:(MotionCapture*) motion{
    Frame * frame = [super currentObject];
    if(frame){
        [frame addCaptureMotion:motion];
    }
    
}
-(void) addMotionCaptureToPreviousFrame:(MotionCapture*) motion{
    Frame * frame = [super previousObject];
    if (frame) {
        [frame addCaptureMotion:motion];
    }
}
-(void) addMotionCapture:(MotionCapture*) motion toPreviousFrame:(NSInteger)n{
    @throw [NSException NotImplementedException];
}

/*Add Frames*/
-(void) addObject:(id)anObject{
    if([anObject class] == [Frame class])
        [super addObject:anObject];
}
-(void) addFrame:(Frame*) frame{
    if (frame) {
        [super addObject:frame];
    }
}

/*Navigate between frames*/
-(id) currentFrame{
    return [super currentObject];    
}

-(id) previousFrame{
    return [super previousObject];
}

-(id) previousFrame:(NSUInteger)n{
    return [super previousObject:n];
}

-(id) frameAtIndex:(NSUInteger)index{
    return [super objectAtIndex:index];
}

#pragma mark - Delegate functions
-(void) objectWasErasedAtIndex:(NSUInteger)index{
    
}
-(void) objectWasAddedAtIndex:(NSUInteger)index{
}

-(void) objectWillBeAddedAtIndex:(NSUInteger)index{
    
}

-(void) objectWillBeErasedAtIndex:(NSUInteger)index{
}

@end
