//
//  CircularFrameProcessingQueueTests.m
//  MotionDetection
//
//  Created by Kevin Toublanc on 04/01/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CircularFrameProcessingQueueTests.h"

#import <UIKit/UIKit.h>
#import "CircularFrameProcessingQueue.h"
#import "Frame.h"
#import <CoreMotion/CoreMotion.h>
#import "MotionCapture.h"

@implementation CircularFrameProcessingQueueTests

-(void) testCurrentFrame{
    CircularFrameProcessingQueue * queue = [[CircularFrameProcessingQueue alloc] init];
    STAssertNil([queue currentFrame], @"La frame courante n'est pas nulle, elle le devrait...");
}

-(void) testPreviousFrame{
    CircularFrameProcessingQueue * queue = [[CircularFrameProcessingQueue alloc] init];
    STAssertNil([queue previousFrame], @"La frame courante n'est pas nulle, elle le devrait...");
}

-(void) testInsert{
    CircularFrameProcessingQueue * queue = [[CircularFrameProcessingQueue alloc] init];
    Frame * frame = [[Frame alloc] init];
    [queue addFrame:frame];
    STAssertEquals([queue count], (NSUInteger)1 , @"L'ajout à échoué");
}

-(void) testAddMotion{
    CircularFrameProcessingQueue * queue = [[CircularFrameProcessingQueue alloc] init];
    
    
    CMMotionManager * manager = [[CMMotionManager alloc] init];
    [manager startDeviceMotionUpdates];
    
    for (int i = 0;  i < 12; i++) {
        Frame * frame = [[Frame alloc] init];
        [queue addFrame:frame];
        for (int j = 0; j < 20; j++) {
            MotionCapture * motion = [[MotionCapture alloc] initWithDeviceMotion:manager.deviceMotion];
            [queue addMotionCaptureToCurrentFrame:motion];
            [NSThread sleepForTimeInterval:0.001];
        }
        
    }
    STAssertEquals([queue count], (NSUInteger)10 , @"L'ajout à échoué");
    //STAssertEquals([[[queue currentFrame] motions] count] , (NSUInteger)20 , @"L'ajout à échoué");
    //STAssertEquals([[[queue previousFrame] motions] count] , (NSUInteger)20 , @"L'ajout à échoué");
    
}

-(void) testAddMotionToPreviousFrame{
    CircularFrameProcessingQueue * queue = [[CircularFrameProcessingQueue alloc] init];
    
    
    CMMotionManager * manager = [[CMMotionManager alloc] init];
    [manager startDeviceMotionUpdates];
    
    for (int i = 0;  i < 12; i++) {
        Frame * frame = [[Frame alloc] init];
        [queue addFrame:frame];
        for (int j = 0; j < 20; j++) {
            MotionCapture * motion = [[MotionCapture alloc] initWithDeviceMotion:manager.deviceMotion];
            [queue addMotionCaptureToCurrentFrame:motion];
            [NSThread sleepForTimeInterval:0.001];
        }
        
    }
    MotionCapture * motion = [[MotionCapture alloc] initWithDeviceMotion:manager.deviceMotion];
    [queue addMotionCaptureToPreviousFrame:motion];
    //STAssertEquals([[[queue previousFrame] motions] count] , (NSUInteger)21 , @"L'ajout à échoué");
    
}

@end
