
//
//  SimpleConvolutionMaskTest.m
//  MotionDetection
//
//  Created by Kévin Toublanc on 11/04/12.
//  Copyright (c) 2012 Polytech'Tours. All rights reserved.
//

#import "SimpleConvolutionMaskTest.h"

@implementation SimpleConvolutionMaskTest

@synthesize mask=_mask;

-(SimpleConvolutionMask *)mask{
    if(!_mask){
        _mask = [[SimpleConvolutionMask alloc] initWithImage:image 
                                                   imageSize:imageS 
                                                 resultImage:result 
                                                        mask:mask 
                                                    maskSize:maskS 
                                                    delegate:nil];
    }
    return _mask;
}

-(void)setUp{
    imageS.width = 10;
    imageS.height= 5;
    
    maskS.width = 3;
    maskS.height = 3;
    
    image = malloc(NB_OCTET_PAR_PIXEL * imageS.width * imageS.height * sizeof(uint8_t));
    result = malloc(imageS.width * imageS.height * sizeof(int));
    mask = malloc(maskS.width * maskS.height * sizeof(int));
    NSString *s = @"IMAGE \n";
    for (int i = 0; i < imageS.height; i++) {
        for (int j = 0; j < imageS.width; j++) {
            for (int k=0; k<NB_OCTET_PAR_PIXEL; k++) {
                image[(int)(NB_OCTET_PAR_PIXEL * (i * imageS.width + j) + k)] = 
                    (uint8_t) ((float)(rand() / (float)RAND_MAX) * 255.0);
                s= [NSString stringWithFormat:@"%@\t%d", 
                    s, 
                    image[(int)(NB_OCTET_PAR_PIXEL * (i * imageS.width + j) + k)]
                    ];
            }
            s = [NSString stringWithFormat:@"%@\t",s];
        }
        s = [NSString stringWithFormat:@"%@\n",s];
    }
    NSLog(@"%@",s);
    s = @"MASK \n";
    for (int i = 0; i < maskS.height; i++) {
        for (int j = 0; j < maskS.width; j++) {
            
            if(i == 1 && j == 1){
                mask[(int)(i * maskS.width + j)] = 8;//(uint8_t) (((float)rand() / (float)RAND_MAX) * 5.0);
            }else {
                mask[(int)(i * maskS.width + j)] = -1;//(uint8_t) (((float)rand() / (float)RAND_MAX) * 5.0);
            }
                
                s= [NSString stringWithFormat:@"%@\t%d", 
                    s, 
                    mask[(int)(i * maskS.width + j)]
                    ];
        }
        s = [NSString stringWithFormat:@"%@\n",s];
    }
    NSLog(@"%@",s);

}

-(void) testApplyMask{
    NSString *s = @"RESULT \n";
    [[self mask] applyMask];
    for (int i = 0; i < imageS.height; i++) {
        for (int j = 0; j < imageS.width; j++) {
                s= [NSString stringWithFormat:@"%@\t%d", 
                    s, 
                    self.mask.result[(int)(i * imageS.width + j )]
                 ];
        }
        s = [NSString stringWithFormat:@"%@\n",s];
        
    }
    NSLog(@"%@",s);
}


-(void) testValMask{
    mask = malloc(9 * sizeof(int));
    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 3; j++) {
            if(i == 1 && j == 1){
                mask[(int)(i * 3 + j)] = 4;
            }else {
                if((i == 1 && (j==0 || j==2) )||((i==0 || i==2) && j==1))
                    mask[(int)(i * 3 + j)] = -1;
            }
            
            NSLog(@"%d",mask[(int)(i * 3 + j)]);
        }
    }

}
@end


